/*
** Destop's player plugin
** Copyright (c) 2003 Destop - CZN
**
*/

#include <windows.h>
#include <mmreg.h>
#include <msacm.h>
#include <math.h>
#include "in2.h"
#include "dspadpcm.h"

#ifdef _DEBUG

void __cdecl DisplayError (char * Message, ...) {
	char Msg[400];
	va_list ap;

	va_start( ap, Message );
	vsprintf( Msg, Message, ap );
	va_end( ap );
	MessageBox(NULL,Msg,"Error",MB_OK|MB_ICONERROR|MB_SETFOREGROUND);
}
#else
void __cdecl DisplayError (char * Message, ...) {}
#endif



// avoid CRT. Evil. Big. Bloated.
BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

// post this to the main window at end of file (after playback as stopped)
#define WM_WA_MPEG_EOF WM_USER+2
// raw configuration
#define BPS 16

int interleavebytes;
int interleavesamples;
#define looptimes 2
#define masterfadelength 10
#define loopsplice 2048
#define loopstyle_sfass 0
#define loopstyle_mp2 1

char lastfn[MAX_PATH]; // currently playing file (used for getting info on the current file)
char sample_buffer[576*2*2]; // sample buffer

int file_length; // file length, in bytes
int buffer_size;
int decode_pos_ms; // current decoding position, in milliseconds
int paused; // are we paused?
int seek_needed; // if != -1, it is the point that the decode thread should seek to, in ms.
int killDecodeThread=0;					// the kill switch for the decode thread
int NCH = 2;
int SAMPLERATE = 44100;
int	last_fpos=0,loop_fpos;
char *dspbuffer;
char *file_buffer;
long fadecount, fadelength;
int loopsplicecount;
short loopspliceleft,loopspliceright;
short loopsplice2left,loopsplice2right;
int loopstyle;
sDSPADPCM dsp,dsp2;
ADPCMINFO *pcmi;
//short ebp0Ch,ebp10h;

In_Module mod; // the output module (declared near the bottom of this file)

HANDLE input_file=INVALID_HANDLE_VALUE; // input file handle
HANDLE thread_handle=INVALID_HANDLE_VALUE;	// the handle to the decode thread

DWORD WINAPI __stdcall DecodeThread(void *b); // the decode thread procedure

typedef struct
{
  int s1, s2;
} PREV;

PREV prev[2];


void config(HWND hwndParent)
{
	MessageBox(hwndParent,
		"No configuration.",
		"Configuration",MB_OK);
	// if we had a configuration we'd want to write it here :)
}

void about(HWND hwndParent)
{
	MessageBox(hwndParent,"Destop's DSP Player.\n\n For Playing NGC DSP files\n\n Destop-CZN (c) 2003\n\nv1.2 Modified by hcs","Destop's DSP Player",MB_OK);
}

void init() { /* any one-time initialization goes here (configuration reading, etc) */ 
}

void quit() { /* one-time deinit, such as memory freeing */ 
	VirtualFree(dspbuffer,0,MEM_RELEASE);

}

int isourfile(char *fn) { return 0; } 
// used for detecting URL streams.. unused here. strncmp(fn,"http://",7) to detect HTTP streams, etc


int get16bit(unsigned char* p)
{
	return (p[0] << 8) | p[1];
}

int get32bit(unsigned char* p)
{
	return (p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3];
}


int nrsamples;

// standard devkit version
void get_dspheaderstd(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	dsp->num_samples=get32bit(buf);
	dsp->num_adpcm_nibbles=get32bit(buf+4);
	dsp->sample_rate=get32bit(buf+8);
	dsp->loop_flag=get16bit(buf+0xC);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=2*get32bit(buf+0x10);
	dsp->ea=get32bit(buf+0x14);
	dsp->ca=get32bit(buf+0x18);
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x1C+i*2);
	dsp->gain=get16bit(buf+0x3C);
	dsp->ps=get16bit(buf+0x3E);
	dsp->yn1=get16bit(buf+0x40);
	dsp->yn2=get16bit(buf+0x42);
	dsp->lps=get16bit(buf+0x44);
	dsp->lyn1=get16bit(buf+0x46);
	dsp->lyn2=get16bit(buf+0x48);
	for(i=0;i<11;i++)
	dsp->pad[i]=get16bit(buf+0x4A+i*2);
	loopstyle=loopstyle_sfass;
}

// SF Assault version
void get_dspheadersfa(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	buf+=0x20; // for SF Assault
	dsp->num_samples=get32bit(buf);
	dsp->num_adpcm_nibbles=get32bit(buf+4);
	dsp->sample_rate=get32bit(buf+8);
	dsp->loop_flag=get16bit(buf+0xC);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=2*get32bit(buf+0x10);
	dsp->ea=get32bit(buf+0x14);
	dsp->ca=get32bit(buf+0x18);
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x1C+i*2);
	dsp->gain=get16bit(buf+0x3C);
	dsp->ps=get16bit(buf+0x3E);
	dsp->yn1=get16bit(buf+0x40);
	dsp->yn2=get16bit(buf+0x42);
	dsp->lps=get16bit(buf+0x44);
	dsp->lyn1=get16bit(buf+0x46);
	dsp->lyn2=get16bit(buf+0x48);
	for(i=0;i<11;i++)
	dsp->pad[i]=get16bit(buf+0x4A+i*2);
	loopstyle=loopstyle_sfass;
}

// Metroid Prime 2 version
void get_dspheadermp2(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	dsp->num_samples=get32bit(buf+0x8);
	dsp->num_adpcm_nibbles=get32bit(buf+0x10);
	dsp->sample_rate=get32bit(buf+0x0c);
	dsp->loop_flag=get16bit(buf+0x14);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=2*get32bit(buf+0x18);
	dsp->ea=2*get32bit(buf+0x1c);
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x20+i*2);
	dsp->yn1=dsp->yn2=0;
	loopstyle=loopstyle_mp2;
}

// Metroid Prime 2 version
void get_dspheadermp22(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	dsp->num_samples=get32bit(buf+0x8);
	dsp->num_adpcm_nibbles=get32bit(buf+0x10);
	dsp->sample_rate=get32bit(buf+0x0c);
	dsp->loop_flag=get16bit(buf+0x14);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=2*get32bit(buf+0x18);
	dsp->ea=2*get32bit(buf+0x1c);
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x40+i*2);
	dsp->yn1=dsp->yn2=0;
	loopstyle=loopstyle_mp2;
}

int play(char *fn) 
{ 
	int maxlatency;
	int thread_id;
	unsigned char readbuf[96+96];
	short interleavebuf1[0x14000];
	short interleavebuf2[0x14000];
	int l,c;
	unsigned long i;
	static int doonce=0;
	static int first_alloc_size=0x3000000;
	short ebp0Ch,ebp10h,ebp0Ch2,ebp10h2;

	pcmi=(ADPCMINFO*) dsp.coef;

	input_file = CreateFile(fn,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

	if (input_file == INVALID_HANDLE_VALUE) // error opening file
	{
		return 1;
	}

	ReadFile(input_file, &readbuf, 96+96, &l, NULL);

	if (readbuf[0]=='R' && readbuf[1]=='S' && readbuf[2]==0x00 && readbuf[3]==0x03) {
		get_dspheadermp2(&dsp,readbuf);
		get_dspheadermp22(&dsp2,readbuf);
		SetFilePointer(input_file, 0x60, NULL, FILE_BEGIN);
		interleavebytes=0x8f00;
		NCH=2;
	} else if (readbuf[0]=='C' && readbuf[1]=='s' && readbuf[2]=='t' && readbuf[3]=='r') {
		get_dspheadersfa(&dsp,readbuf);
		get_dspheadersfa(&dsp2,readbuf+0x60);
		SetFilePointer(input_file, 0xE0, NULL, FILE_BEGIN);
		interleavebytes=0x800;
		NCH=2;
	} else {
		// assume standard devkit
		get_dspheaderstd(&dsp,readbuf);
		get_dspheaderstd(&dsp2,readbuf+0x60); // header for channel 2 (duh!)

		// if a valid second header (agrees with first
		if (dsp.num_adpcm_nibbles==dsp2.num_adpcm_nibbles && dsp.num_samples==dsp2.num_samples) {
			// stereo
			NCH=2;
			SetFilePointer(input_file, 0xc0, NULL, FILE_BEGIN);
			interleavebytes=0x8000;
		} else {
			// mono
			NCH=1;
			SetFilePointer(input_file, 0x60, NULL, FILE_BEGIN);
			interleavebytes=0x10;
		}
	}

	interleavesamples=(interleavebytes/8*14);

	if (doonce==0)			//Alloc Only ONCE!@!@!@!
	{
		dspbuffer=VirtualAlloc(0,first_alloc_size,MEM_COMMIT,PAGE_READWRITE|PAGE_NOCACHE);
		if(dspbuffer == 0) 
		{
			CloseHandle(input_file);
			MessageBox(NULL, "VirtualAlloc Failed Need 48MEGS for audio buffer", "DSP error", MB_OK);
			return 1;
		}
		doonce=1;
	}
	//VirtualUnlock(dspbuffer,buffer_size);
	//NCH = 1;	//1channel for now
	//NCH = 2;
	buffer_size=getBytesForPcmBuffer(dsp.num_samples)*NCH;
	//DisplayError("buffer_size=%li",buffer_size);
	if(buffer_size > first_alloc_size) 
	{
		CloseHandle(input_file);
		first_alloc_size=buffer_size;
		doonce=0;
		VirtualFree(dspbuffer,0,MEM_RELEASE);
		MessageBox(NULL, "thats a BIG DSP;) try again we'll allocate some more", "DSP error", MB_OK);
		return 1;
	}


	if(dspbuffer == 0) 
	{
		CloseHandle(input_file);
		MessageBox(NULL, "VirtualAlloc Failed [possible invalid File]", "DSP error", MB_OK);
		return 1;
	}
	//l=VirtualLock(dspbuffer,buffer_size+0x80000);


	SAMPLERATE = dsp.sample_rate;
	if (!dsp.loop_flag) nrsamples = dsp.num_samples;
	else nrsamples = (dsp.sa+looptimes*(dsp.ea-dsp.sa))*14/(2*8)+masterfadelength*SAMPLERATE;
	//else nrsamples = (dsp.sa*2+looptimes*(dsp.ea*2-dsp.sa*2))*14/16+masterfadelength*SAMPLERATE;

	if (dsp.loop_flag) dsp.loop_flag=looptimes; //used as loop counter
	
    file_length=GetFileSize(input_file,NULL);

	//SetFilePointer(input_file, 0xE0, NULL, FILE_BEGIN);
	//SetFilePointer(input_file, 0x80, NULL, FILE_BEGIN);
	//SetFilePointer(input_file, 0x60, NULL, FILE_BEGIN);

	ebp0Ch=dsp.yn1;ebp10h=dsp.yn2;
	ebp0Ch2=dsp.yn1;ebp10h2=dsp.yn2;
	//ebp0Ch=ebp10h=ebp0Ch2=ebp10h2=0;


	loop_fpos=0;
	fadecount=-1;
	fadelength=1;
	loopsplicecount=0;

	//decodeFILE(input_file,(short*)dspbuffer,(ADPCMINFO*)dsp.coef,dsp.num_samples,&ebp0Ch,&ebp10h);
	for (i=0; i <= dsp.num_samples/(interleavesamples)+2; i++) {
		//decodeFILEalt(input_file,interleavebuf1,(ADPCMINFO*)dsp.coef,interleavesamples,&ebp0Ch,&ebp10h,&(dsp.ps));
		//decodeFILEalt(input_file,interleavebuf2,(ADPCMINFO*)dsp2.coef,interleavesamples,&ebp0Ch2,&ebp10h2,&(dsp2.ps));
		
		decodeFILE(input_file,interleavebuf1,(ADPCMINFO*)dsp.coef,interleavesamples,&ebp0Ch,&ebp10h);
		if (NCH==2) decodeFILE(input_file,interleavebuf2,(ADPCMINFO*)dsp2.coef,interleavesamples,&ebp0Ch2,&ebp10h2,32);

		for (c=0; c < interleavesamples; c++) {
			((short*)dspbuffer)[(i*interleavesamples+c)*NCH]=interleavebuf1[c];
			if (NCH==2) ((short*)dspbuffer)[(i*interleavesamples+c)*NCH+1]=interleavebuf2[c];
			
			if (!loop_fpos &&
			 ( (loopstyle==loopstyle_mp2 && 2*(interleavebytes*(i+(NCH-1)))+c > dsp.ea) ||
			   (loopstyle==loopstyle_sfass && 2*(interleavebytes*(i+(NCH-1)))+c >= dsp.ea ) )
			   ) loop_fpos=NCH*(i*interleavesamples+c)*(BPS/8);
		}
	}
//	decode(file_buffer+0x60,(short*)dspbuffer,(ADPCMINFO*)dsp.coef,dsp.num_samples);

	l=0;
	last_fpos=0;
	lstrcpy(lastfn,fn);
	paused=0;
	decode_pos_ms=0;
	seek_needed=-1;

	maxlatency = mod.outMod->Open(SAMPLERATE,NCH,BPS, -1,-1);
	if (maxlatency < 0) // error opening device
	{
		MessageBox(NULL, "error opening device", "DSP error", MB_OK);
		return 1;
	}
	// dividing by 1000 for the first parameter of setinfo makes it
	// display 'H'... for hundred.. i.e. 14H Kbps.
	mod.SetInfo((SAMPLERATE*BPS*NCH*18/64)/1000,SAMPLERATE/1000,NCH,1);

	// initialize vis stuff
	mod.SAVSAInit(maxlatency,SAMPLERATE);
	mod.VSASetInfo(SAMPLERATE,NCH);

	mod.outMod->SetVolume(-666); // set the output plug-ins default volume

	killDecodeThread=0;
	thread_handle = (HANDLE) CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) DecodeThread,(void *) &killDecodeThread,0,&thread_id);
	
	return 0; 
}


void pause() 
{ 
	paused=1; 
	mod.outMod->Pause(1); 
}


void unpause() 
{ 
	paused=0; 
	mod.outMod->Pause(0); 
}


int ispaused() 
{ 
	return paused; 
}


void stop() 
{ 
	if (thread_handle != INVALID_HANDLE_VALUE)
	{
		killDecodeThread=1;
		if (WaitForSingleObject(thread_handle,INFINITE) == WAIT_TIMEOUT)
		{
			MessageBox(mod.hMainWindow,"error asking thread to die!\n","error killing decode thread",0);
			TerminateThread(thread_handle,0);
		}
		CloseHandle(thread_handle);
		thread_handle = INVALID_HANDLE_VALUE;
	}
	if (input_file != INVALID_HANDLE_VALUE)
	{
		CloseHandle(input_file);
		input_file=INVALID_HANDLE_VALUE;
	}

	mod.outMod->Close();
	mod.SAVSADeInit();
}


int getlength() 
{ 
	return nrsamples/SAMPLERATE*1000;
}


int getoutputtime() 
{ 
	return decode_pos_ms+(mod.outMod->GetOutputTime()-mod.outMod->GetWrittenTime()); 
}


void setoutputtime(int time_in_ms) 
{ 
	seek_needed=time_in_ms; 
}


void setvolume(int volume) 
{ 
	mod.outMod->SetVolume(volume); 
}


void setpan(int pan) 
{ 
	mod.outMod->SetPan(pan); 
}


int infoDlg(char *fn, HWND hwnd)
{
	// TODO: implement info dialog. 
	MessageBox(hwnd,"Heya","Destop's DSP Player",MB_OK);
	return 0;
}

void getfileinfo(char *filename, char *title, int *length_in_ms)
{
	if (!filename || !*filename)  // currently playing file
	{
		if (length_in_ms) *length_in_ms=getlength();
		if (title) 
		{
			char *p=lastfn+lstrlen(lastfn);
			while (*p != '\\' && p >= lastfn) p--;
			lstrcpy(title,++p);
		}
	}
	else // some other file
	{
		if (length_in_ms) 
		{
			HANDLE hFile;
			*length_in_ms=-1000;
			hFile = CreateFile(filename,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
				OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
			if (hFile != INVALID_HANDLE_VALUE)
			{
				*length_in_ms = (GetFileSize(hFile,NULL)*10)/(SAMPLERATE/100*NCH*(BPS/8));
			}
			CloseHandle(hFile);
		}
		if (title) 
		{
			char *p=filename+lstrlen(filename);
			while (*p != '\\' && p >= filename) p--;
			lstrcpy(title,++p);
		}
	}
}


void eq_set(int on, char data[10], int preamp) 
{ 
	// most plug-ins can't even do an EQ anyhow.. I'm working on writing
	// a generic PCM EQ, but it looks like it'll be a little too CPU 
	// consuming to be useful :)
}



#define BASEVOL 0x2000




// render 576 samples into buf. 
// note that if you adjust the size of sample_buffer, for say, 1024
// sample blocks, it will still work, but some of the visualization 
// might not look as good as it could. Stick with 576 sample blocks
// if you can, and have an additional auxiliary (overflow) buffer if 
// necessary.. 


short clamp(double f) {
	if(f > 32767) return 32767;
    if(f < -32768) return -32768;
	return f;
}

int get_576_samples(char *buf)
{

	int i;
/*
	i=SetFilePointer(input_file, 0, NULL, FILE_CURRENT);
	if (i>=file_length)
		return 0;
	decodeFILE(input_file,(short*)buf,(ADPCMINFO*)dsp.coef,560);
	i=560*2;
*/
	
	for (i=0; i < 576; i++) {
		if (fadecount < 0 && !loopsplicecount) CopyMemory(buf,dspbuffer+last_fpos,NCH*(BPS/8));
		else {
			double tempdelta,tempdata;
			if (loopsplicecount==loopsplice) {
				loopsplice2left=((short*)dspbuffer)[last_fpos/2];
				loopsplice2right=((short*)dspbuffer)[last_fpos/2+1];
			}
			if (loopsplicecount) loopsplicecount--;
			// fade is specific to 16-bit, 2 channel
			tempdelta=loopsplice2left-loopspliceleft;
			tempdata=((short*)dspbuffer)[last_fpos/2];
			((short*)buf)[0]=clamp((tempdata-tempdelta*((double)loopsplicecount)/((double)(loopsplice)))*
				((double)(fadecount>0?fadecount:fadelength))/((double)fadelength));
			
			tempdelta=loopsplice2right-loopspliceright;
			tempdata=((short*)dspbuffer)[last_fpos/2+1];
			((short*)buf)[1]=clamp((tempdata-tempdelta*((double)loopsplicecount)/((double)(loopsplice)))*
				((double)(fadecount>0?fadecount:fadelength))/((double)fadelength));
			if (fadecount>0) fadecount--;
			if (fadecount==0) return 0;
		}
		last_fpos+=NCH*(BPS/8); buf+=NCH*(BPS/8);
		//if (last_fpos>=dsp.sa*14*NCH*(BPS/8)/16) DisplayError("loop start");
		//if (dsp.loop_flag && last_fpos >= ((dsp.ea-2*interleavebytes)/interleavebytes*interleavebytes)*14*NCH*(BPS/8)/16) {
		//if (dsp.loop_flag && last_fpos >= dsp.ea*14*NCH*(BPS/8)/16) {
		if (dsp.loop_flag && last_fpos >= loop_fpos) {
			loopspliceleft=((short*)buf)[-2];
			loopspliceright=((short*)buf)[-1];
			loopsplicecount=loopsplice;

			last_fpos = dsp.sa*14*2*(BPS/8)/16;
			//last_fpos = (dsp.sa-0x60)*14*NCH*(BPS/8)/16*2;
			//DisplayError("at loop last_fpos=%08x loop_fpos=%08x",last_fpos,loop_fpos);
			dsp.loop_flag--;
			if (dsp.loop_flag==0) fadelength=fadecount=masterfadelength*dsp.sample_rate;
			//DisplayError("das loop!");
		}
		if (!dsp.loop_flag && last_fpos>=buffer_size) {
			return 0;
		}
	}

	return 576*NCH*(BPS/8);
}


DWORD WINAPI __stdcall DecodeThread(void *b)
{
	int done=0;
	while (! *((int *)b) ) 
	{
		if (seek_needed != -1)
		{
			int offs;
			decode_pos_ms = seek_needed-(seek_needed%1000);
			seek_needed=-1;
			done=0;
			mod.outMod->Flush(decode_pos_ms);
			offs = (decode_pos_ms/1000) * SAMPLERATE;
			last_fpos=offs*NCH*(BPS/8);
/*
			if (last_fpos==0)
				last_fpos=0x60;
			SetFilePointer(input_file, (last_fpos&-8)/14/8, NULL, FILE_BEGIN);
*/
		}
		if (done)
		{
			mod.outMod->CanWrite();
			if (!mod.outMod->IsPlaying())
			{
				PostMessage(mod.hMainWindow,WM_WA_MPEG_EOF,0,0);
				return 0;
			}
			Sleep(10);
		}
		else if (mod.outMod->CanWrite() >= ((576*NCH*(BPS/8))<<(mod.dsp_isactive()?1:0)))
		{	
			int l=576*NCH*(BPS/8);
			l=get_576_samples(sample_buffer);
			if (!l) 
			{
				done=1;
			}
			else
			{
				mod.SAAddPCMData((char *)sample_buffer,NCH,BPS,decode_pos_ms);
				mod.VSAAddPCMData((char *)sample_buffer,NCH,BPS,decode_pos_ms);
				decode_pos_ms+=(576*1000)/SAMPLERATE;
				if (mod.dsp_isactive()) l=mod.dsp_dosamples((short *)sample_buffer,l/NCH/(BPS/8),BPS,NCH,SAMPLERATE)*(NCH*(BPS/8));
				mod.outMod->Write(sample_buffer,l);
			}
		}
		else Sleep(20);
	}
	return 0;
}


In_Module mod = 
{
	IN_VER,
	"Destop's DSP Player v1.2 improved version 11/08/05"
#ifdef _DEBUG
	" (DEBUG)"
#endif
	,
	0,	// hMainWindow
	0,  // hDllInstance
	"DSP\0DSP Audio File (*.DSP)\0GCM\0DSP Audio File (*.GCM)\0"
	,
	1,	// is_seekable
	1, // uses output
	config,
	about,
	init,
	quit,
	getfileinfo,
	infoDlg,
	isourfile,
	play,
	pause,
	unpause,
	ispaused,
	stop,
	
	getlength,
	getoutputtime,
	setoutputtime,

	setvolume,
	setpan,

	0,0,0,0,0,0,0,0,0, // vis stuff


	0,0, // dsp

	eq_set,

	NULL,		// setinfo

	0 // out_mod

};

__declspec( dllexport ) In_Module * winampGetInModule2()
{
	return &mod;
}

int main (void)
{
	return 0;
}
