//================ C R A Z Y N A T I O N ===================================
//==========================================================================
// ADPCM decoder for Nintendo GAMECUBE dsp format
//==========================================================================
#include <windows.h>
#include "dspadpcm.h"

//extern short ebp0Ch,ebp10h;
int decodeFILE
(
    HANDLE input_file,  // location of encoded source samples
    s16         *out,   // location of destination buffer (16 bits / sample)
    ADPCMINFO   *cxt,   // location of adpcm info
    u32         samples, // number of samples to decode         
	short * ebp0Chp,
	short * ebp10hp
)
{
u32 counter;
int sample;
short nibbles[14];
char  buf[16];
int index1;
int i,j;
char *src,*dst;
short delta;
short ebp0Ch=*ebp0Chp;
short ebp10h=*ebp10hp;

    counter = 0;
//    ebp0Ch = 0;
//    ebp10h = 0;
    
	
	dst = (char*)out;
//	SetFilePointer(input_file, 0x60, NULL, FILE_BEGIN);		//start of data

	if(samples != 0) 
	{
		while(1 != 0) {
			ReadFile(input_file, buf, 8, &i, NULL);
			src=buf;
            i = *src&0xFF;
            src++;
            delta = 1 << (i & 255 & 15);
            index1 = (i & 255) >> 4;

            for(i = 0; i < 14; i = i + 2) {
                j = ( *src & 255) >> 4;
                nibbles[i] = j;
                j = *src & 255 & 15;
                nibbles[i+1] = j;
                src++;
            }

            for(i = 0; i < 14; i = i + 1) {
                if(nibbles[i] >= 8) 
                    nibbles[i] = nibbles[i] - 16;
                
            }
            for(i = 0; i<14 ; i = i + 1) {

                sample = (delta * nibbles[i])<<11;
                sample += cxt->coef[index1*2] * ebp0Ch;
                sample += cxt->coef[index1*2+1] * ebp10h;
                sample = sample + 1024;
                sample = sample >> 11;
                if(sample > 32767) {
                    sample = 32767;
                }
                if(sample < -32768) {
                    sample = -32768;
                }
                
                *(short*)dst = (short)sample;
                dst = dst + 2;

                ebp10h = ebp0Ch;
                ebp0Ch = (short)sample;
                counter++;
                if(counter == samples) 
                    break;
            }
        if(counter == samples) 
          break;
           
        } //while
    }
	*ebp0Chp=ebp0Ch;
	*ebp10hp=ebp10h;

    return((int)src);
}

u32 getBytesForPcmBuffer(u32 samples){
	int i;
    i=samples/14;

    if(samples%14 != 0)
       i++;

    i=i*14;
    return(i << 1);
}
